/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20160212-64
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt1.dat, Sat Aug 13 18:53:35 2016
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000003D3 (979)
 *     Revision         0x02
 *     Checksum         0xD6
 *     OEM ID           "INTEL "
 *     OEM Table ID     "UsbCTabl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20120913 (538052883)
 */
DefinitionBlock ("ssdt1.aml", "SSDT", 2, "INTEL ", "UsbCTabl", 0x00001000)
{

    External (_SB_.SGII, MethodObj)    // 2 Arguments
    External (GSSM, MethodObj)    // 2 Arguments
    External (OSYS, UnknownObj)
    External (UBCB, IntObj)
    External (XDCE, IntObj)

    Scope (\_SB)
    {
        Device (UBTC)
        {
            Name (_HID, EisaId ("USBC000"))  // _HID: Hardware ID
            Name (_CID, EisaId ("PNP0CA0"))  // _CID: Compatible ID
            Name (_UID, Zero)  // _UID: Unique ID
            Name (_DDN, "USB Type C")  // _DDN: DOS Device Name
            Name (_ADR, Zero)  // _ADR: Address
            Name (CRS, ResourceTemplate ()
            {
                Memory32Fixed (ReadWrite,
                    0x00000000,         // Address Base
                    0x00001000,         // Address Length
                    _Y00)
            })
            Device (CR01)
            {
                Name (HSVP, Package (0x10)
                {
                    One, 
                    One, 
                    One, 
                    One, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                })
                Name (HGIP, Package (0x0C)
                {
                    One, 
                    0x02, 
                    0x03, 
                    0x04, 
                    0x05, 
                    0x06, 
                    0x07, 
                    0x08, 
                    0x09, 
                    0x0A, 
                    0x0B, 
                    0x0C
                })
                Name (HGPP, Package (0x0C)
                {
                    One, 
                    One, 
                    One, 
                    One, 
                    One, 
                    One, 
                    One, 
                    One, 
                    One, 
                    One, 
                    One, 
                    One
                })
                Name (SSVP, Package (0x08)
                {
                    One, 
                    Zero, 
                    One, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Zero
                })
                Name (SGIP, Package (0x06)
                {
                    One, 
                    0x02, 
                    0x03, 
                    0x04, 
                    0x11, 
                    0x12
                })
                Name (SGPP, Package (0x06)
                {
                    One, 
                    One, 
                    One, 
                    One, 
                    One, 
                    One
                })
                Name (_ADR, Zero)  // _ADR: Address
                Method (_PLD, 0, Serialized)  // _PLD: Physical Location of Device
                {
                    Name (PLDP, Package (0x01)
                    {
                        Buffer (0x14)
                        {
                            /* 0000 */  0x82, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  /* ........ */
                            /* 0008 */  0x70, 0x1D, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  /* p....... */
                            /* 0010 */  0xFF, 0xFF, 0xFF, 0xFF                           /* .... */
                        }
                    })
                    CreateBitField (DerefOf (PLDP [Zero]), 0x40, VISS)
                    VISS = DerefOf (SSVP [0x02])
                    CreateField (DerefOf (PLDP [Zero]), 0x4F, 0x08, GID)
                    GID = DerefOf (SGIP [0x02])
                    CreateField (DerefOf (PLDP [Zero]), 0x57, 0x08, GPOS)
                    GPOS = DerefOf (SGPP [0x02])
                    CreateField (DerefOf (PLDP [Zero]), 0x4A, 0x04, SHAP)
                    SHAP = One
                    CreateField (DerefOf (PLDP [Zero]), 0x20, 0x10, WID)
                    WID = 0x08
                    CreateField (DerefOf (PLDP [Zero]), 0x30, 0x10, HGT)
                    HGT = 0x03
                    Return (PLDP) /* \_SB_.UBTC.CR01._PLD.PLDP */
                }

                Method (_UPC, 0, Serialized)  // _UPC: USB Port Capabilities
                {
                    Name (UPCP, Package (0x04)
                    {
                        0xFF, 
                        0x09, 
                        Zero, 
                        Zero
                    })
                    Return (UPCP) /* \_SB_.UBTC.CR01._UPC.UPCP */
                }
            }

            Method (_CRS, 0, Serialized)  // _CRS: Current Resource Settings
            {
                CreateDWordField (CRS, \_SB.UBTC._Y00._BAS, CBAS)  // _BAS: Base Address
                CBAS = UBCB /* External reference */
                Return (CRS) /* \_SB_.UBTC.CRS_ */
            }

            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                If ((OSYS < 0x07DF))
                {
                    Return (Zero)
                }
                Else
                {
                    Return (0x0F)
                }
            }

            OperationRegion (USBC, SystemMemory, UBCB, 0x38)
            Field (USBC, ByteAcc, Lock, Preserve)
            {
                VER1,   8, 
                VER2,   8, 
                RSV1,   8, 
                RSV2,   8, 
                CCI0,   8, 
                CCI1,   8, 
                CCI2,   8, 
                CCI3,   8, 
                CTL0,   8, 
                CTL1,   8, 
                CTL2,   8, 
                CTL3,   8, 
                CTL4,   8, 
                CTL5,   8, 
                CTL6,   8, 
                CTL7,   8, 
                MGI0,   8, 
                MGI1,   8, 
                MGI2,   8, 
                MGI3,   8, 
                MGI4,   8, 
                MGI5,   8, 
                MGI6,   8, 
                MGI7,   8, 
                MGI8,   8, 
                MGI9,   8, 
                MGIA,   8, 
                MGIB,   8, 
                MGIC,   8, 
                MGID,   8, 
                MGIE,   8, 
                MGIF,   8, 
                MGO0,   8, 
                MGO1,   8, 
                MGO2,   8, 
                MGO3,   8, 
                MGO4,   8, 
                MGO5,   8, 
                MGO6,   8, 
                MGO7,   8, 
                MGO8,   8, 
                MGO9,   8, 
                MGOA,   8, 
                MGOB,   8, 
                MGOC,   8, 
                MGOD,   8, 
                MGOE,   8, 
                MGOF,   8
            }

            Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
            {
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                If ((Arg0 == ToUUID ("6f8398c2-7ca4-11e4-ad36-631042b5008f")))
                {
                    While (One)
                    {
                        _T_0 = ToInteger (Arg2)
                        If ((_T_0 == Zero))
                        {
                            Return (Buffer (One)
                            {
                                 0x0F                                             /* . */
                            })
                        }
                        ElseIf ((_T_0 == One))
                        {
                            GSSM (0xF1, Zero)
                        }
                        ElseIf ((_T_0 == 0x02))
                        {
                            GSSM (0xF2, Zero)
                        }
                        ElseIf ((_T_0 == 0x03))
                        {
                            Return (XDCE) /* External reference */
                        }

                        Break
                    }
                }

                Return (Zero)
            }
        }

        Scope (\_GPE)
        {
            Method (_L13, 0, Serialized)  // _Lxx: Level-Triggered GPE
            {
                Notify (\_SB.UBTC, 0x80) // Status Change
                \_SB.SGII (0x02010013, One)
            }
        }
    }
}

